#!/usr/bin/env python
# -*- coding: euc-jp -*-


##
#
# @file OutPortConnector.py
# @brief OutPort Connector class
# @date $Date$
# @author Noriaki Ando <n-ando@aist.go.jp> and Shinji Kurihara
#
# Copyright (C) 2009
#     Noriaki Ando
#     Task-intelligence Research Group,
#     Intelligent Systems Research Institute,
#     National Institute of
#         Advanced Industrial Science and Technology (AIST), Japan
#     All rights reserved.
#

import OpenRTM_aist


##
# @if jp
# @class OutPortConnector
# @brief OutPortConnector 쥯饹
#
# OutPort  Push/Pull Ƽ Connector 뤿
# 쥯饹
#
# @since 1.0.0
#
# @else
# @class OutPortConnector
# @brief IPortConnector base class
#
# The base class to derive subclasses for OutPort's Push/Pull Connectors
#
# @since 1.0.0
#
# @endif
#
class OutPortConnector(OpenRTM_aist.ConnectorBase):

    ##
    # @if jp
    # @brief 󥹥ȥ饯
    # @else
    # @brief Constructor
    # @endif
    #
    # OutPortConnector(ConnectorBase::Profile& profile);
    def __init__(self, profile):
        self._rtcout = OpenRTM_aist.Manager.instance().getLogbuf("OutPortConnector")
        self._profile = profile
        return

    ##
    # @if jp
    # @brief ǥȥ饯
    # @else
    # @brief Destructor
    # @endif
    #
    def __del__(self):
        pass


    ##
    # @if jp
    # @brief Profile 
    #
    # Connector Profile 
    #
    # @else
    # @brief Getting Profile
    #
    # This operation returns Connector Profile
    #
    # @endif
    #
    # const Profile& profile();
    def profile(self):
        self._rtcout.RTC_TRACE("profile()")
        return self._profile

    ##
    # @if jp
    # @brief Connector ID 
    #
    # Connector ID 
    #
    # @else
    # @brief Getting Connector ID
    #
    # This operation returns Connector ID
    #
    # @endif
    #
    # const char* id();
    def id(self):
        self._rtcout.RTC_TRACE("id() = %s", self.profile().id)
        return self.profile().id


    ##
    # @if jp
    # @brief Connector ̾
    #
    # Connector ̾
    #
    # @else
    # @brief Getting Connector name
    #
    # This operation returns Connector name
    #
    # @endif
    #
    # const char* name();
    def name(self):
        self._rtcout.RTC_TRACE("name() = %s", self.profile().name)
        return self.profile().name

