#!/usr/bin/env python
# -*- coding: euc-jp -*-

##
# @file  PublisherFactory.py
# @brief PublisherFactory class
# @date  $Date: 2007/09/05$
# @author Noriaki Ando <n-ando@aist.go.jp>
#
# Copyright (C) 2006-2008
#     Noriaki Ando
#     Task-intelligence Research Group,
#     Intelligent Systems Research Institute,
#     National Institute of
#         Advanced Industrial Science and Technology (AIST), Japan
#     All rights reserved.

from omniORB import any

import OpenRTM_aist


##
# @if jp
# @class PublisherFactory
# @brief PublisherFactory 饹
#
# ƼPublisher֥Ȥ˴եȥꥯ饹
# ƥݥʼ
#   ŪˤǤդPublisherǤ褦ˤ롣
#
# @else
# @class PublisherFactory
# @brief PublisherFactory class
# @endif
class PublisherFactory:
  """
  """


  ##
  # @if jp
  # @brief Publisher
  #
  # Publisher֥Ȥ롣
  # ꤵ줿˱ŬڤPublisherΥ֥Ȥ롣
  # Publisherμ̤򡢻ꤵ줿Property֥Ȥ
  # dataport.subscription_typeФꤷƤɬפ롣
  # ޤ̤ˤäƤϡPublisherζư椹򤵤ꤹɬפ
  # 롣
  # ζŪƤϡ줾Publisher򻲾ȤΤȡ
  #
  # @param self
  # @param consumer PublisherˤäƥǡФư륳󥷥塼
  # @param property ٤Publisherꤹ뤿ξ䡢Publisher
  #                 ư椹뤿ξꤵƤProperty֥
  #                 
  #
  # @return Publisher֥ȡ˼ԤNull֤
  #
  # @else
  # @brief Create Publisher
  # @endif
  def create(self, consumer, property):
    pub_type = property.getProperty("dataport.subscription_type", "New")

    if type(pub_type) != str :
      pub_type = str(any.from_any(pub_type,keep_structs=True))
    if pub_type == "New":
      return OpenRTM_aist.PublisherNew(consumer, property)
    elif pub_type == "Periodic":
      return OpenRTM_aist.PublisherPeriodic(consumer, property)
    elif pub_type == "Flush":
      return OpenRTM_aist.PublisherFlush(consumer, property)

    return None


  ##
  # @if jp
  # @brief Publisher˴
  #
  # ꤵ줿Publisher֥Ȥ˴롣
  #
  # @param self
  # @param publisher ˴оPublisher֥
  #
  # @else
  # @brief Destroy Publisher
  # @endif
  def destroy(self, publisher):
    if publisher:
      publisher.release()
    del publisher
